#!/usr/bin/env bash

set -Eeuo pipefail

BASE_URL=https://archive.is/timegate
ARCHIVE_URL=https://archive.is/?url
BROWSER=firefox

check() {
    article="$1"
    if [ -z "$article" ]; then
        echo "Please provide an article to archive" >&2
        exit 1
    fi
    if https --verify no "$BASE_URL/$article" | grep -iq "archive this url"; then
        echo "Article not found in archive... archiving now" >&2
        $BROWSER "$ARCHIVE_URL=$article"
        exit 0
    fi
}

while getopts "o:p:" opt; do
    case $opt in
    o)
        article="$OPTARG"
        check "$article"
        $BROWSER "$BASE_URL/$article"
        ;;
    p)
        article="$OPTARG"
        check "$article"
        printf "%s\n" "$BASE_URL/$article"
        ;;
    *)
        echo "Invalid option: $OPTARG" >&2
        ;;
    esac
done
